/* 
	Global API - Jumpstats Module ~ Forwards

	Author: 	Chuckles, Sikari & Zach47
	Source:		""
	
*/

static Handle H_OnValidAndWorthyJump;

void CreateForwards()
{
	H_OnValidAndWorthyJump = CreateGlobalForward("GlobalAPI_JS_ValidJump", ET_Ignore, Param_Cell, Param_Cell, Param_Cell, Param_Float, Param_Cell);
}

public void API_OnAPIKeyReloaded()
{
	GlobalAPI_GetAPIKey(gSZ_API_Key, sizeof(gSZ_API_Key));
}

public void API_OnDevelopmentMode(bool developmentmode)
{
	gB_Staging = developmentmode;
}

public int KZTimer_OnJumpstatStarted(int client)
{
	in_air_calcs(client, true);
	g_jump[client][recording_jump] = true;
}

public int KZTimer_OnJumpstatCompleted(int client, int jumptype, int jumpcolor, float distance, bool personalbest)
{
    int tick;
    tick = g_jump[client][total_ticks];

    //Set End Tick
    g_jump[client][end_tick] = g_jump[client][total_ticks];
    
    update_json_tick_data(client);
    
    float x1 = g_jump[client][player_pos][x][0];
    float x2 = g_jump[client][player_pos][x][tick];
    
    float y1 = g_jump[client][player_pos][y][0];
    float y2 = g_jump[client][player_pos][y][tick];

    float full_distance = SquareRoot(Pow((x2 - x1), 2.0) + Pow((y2 - y1), 2.0)) + 32;
    
    //Ladders are special....
    if(jumptype == view_as<int>(APIJumptype_Ladderjump))
    {
        full_distance = distance;
    }
    
    bool worth_saving = false;
    
    if (jumpcolor >= 3 && !g_jump[client][is_cj_boost])
    {
        worth_saving = true;
    }
    
    else if(jumpcolor >= 3 && personalbest)
    {
        worth_saving = true;
    }

    else if(jumpcolor >= 4)
    {
        worth_saving = true;
    }
    
    if (worth_saving) 
    {	
        Call_StartForward(H_OnValidAndWorthyJump);
        Call_PushCell(client);
        Call_PushCell(jumptype);
        Call_PushCell(jumpcolor);
        Call_PushFloat(full_distance);
        Call_PushCell(personalbest);
        Call_Finish();
    }
    else
    {
        Jumpstats_Reset(client);
    }    
}

public int KZTimer_OnJumpstatInvalid(int client)
{
	Jumpstats_Reset(client);
	g_jump[client][recording_jump] = false;
}

public int GOKZ_JS_OnTakeoff(int client, int jumpType)
{
	in_air_calcs(client, true);
	g_jump[client][recording_jump] = true;
}

public int GOKZ_JS_OnJumpInvalidated(int client)
{
	Jumpstats_Reset(client);
	g_jump[client][recording_jump] = false;
}


